function installtwotone()
% linux users who have matlab installed to a shared location will need to
% run this as sudo.

ostype = computer();
% path of currentFunction
currentFunctionPath = mfilename('fullpath');
% this is in the install directory 
twotoneBundleDirectory = fileparts(currentFunctionPath);

mfitsioLib = 'mfitsio2';
twotoneLib = 'twotone3.1';

if strcmp(ostype,'PCWIN')
  mfitsioBin = 'mfitsio2_bin_Win32';
elseif strcmp(ostype,'GLNX86')%linux 32bit 
  mfitsioBin = 'mfitsio2_bin_Linux32';
elseif strcmp(ostype,'GLNXA64')%linux 64bit 
  mfitsioBin = 'mfitsio2_bin_Linux64';
end

mfitsiopath = fullfile(twotoneBundleDirectory,mfitsioLib,mfitsioBin);
twotonepath = fullfile(twotoneBundleDirectory,twotoneLib);

addpath(mfitsiopath);
addpath(twotonepath);
savepath();

